<?php
namespace App\Controller;

use App\Controller\AppController;
use App\Model\Entity\User;
use App\Model\Table\CategoriesTable;
use App\Model\Table\UsersTable;
use Cake\I18n\I18n;
use Cake\Controller\Component\CookieComponent;
use App\Controller\Component\MathComponent;
/**
 * Products Controller
 * @property MathComponent $Math
 * @property ProductsTable $Products
 * @property CategoriesTableTable $Categories
 */
class ProductsController extends AppController
{

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub

        $this->loadModel('Products');
    }
    public function index()
    {
//        $a = $this->Math->doComplexOperation(1,2);
//        $this->set('a',$a);
        $this->paginate = [
            'limit' => 2,
        ];
        $query = $this->Products->find("all")->contain(['Categories']);
        $this->set('products',$this->paginate($query));
    }

    /**
     * View method
     *
     * @param string|null $id Product id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $id = $_GET['id'];
        $product = $this->Products->get($id, [
            'contain' => []
        ]);
        $this->set('product', $product);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $product = $this->Products->newEntity();
        if ($this->request->is('post')) {
            $product = $this->Products->patchEntity($product, $this->request->getData());
            if ($this->Products->save($product)) {
                $this->Flash->success(__('The product has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The product could not be saved. Please, try again.'));
        }
        $this->set(compact('product'));
//        $this->Products->Categories->setDisplayField('created');
        $this->set('category',$this->Products->Categories->find('list'));
    }

    /**
     * Edit method
     *
     * @param string|null $id Product id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $id = $_GET['id'];
        $product = $this->Products->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $product = $this->Products->patchEntity($product, $this->request->getData());
            if ($this->Products->save($product)) {
                $this->Flash->success(__('The product has been update.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__('The product could not be update. Please, try again.'));
        }
        $this->set(compact('product'));
        $this->set('category',$this->Products->Categories->find('list'));
    }

    /**
     * Delete method
     *
     * @param string|null $id Product id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $id = $_GET['id'];
        $this->request->allowMethod(['post', 'delete']);
        $product = $this->Products->get($id);
        if ($this->Products->delete($product)) {
            $this->Flash->success(__('The product has been deleted.'));
        } else {
            $this->Flash->error(__('The product could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
